<cfsetting enablecfoutputonly="yes" />
<!--------------------------------------------------------------------
Search Results (template):
 - dmInclude (_search.cfm)
Version: v2.1
Date: 2006-04-18
Note: Please feel free to customize the three variables near the top
      of the code:  url.show, Variables.BarCharacter,
                    and Variables.NumOfBar_total
--------------------------------------------------------------------->
<!--- @@displayname: Search Results Page --->
<!--- @@author: Jeff Coughlin (jeff@jeffcoughlin.com), Geoff Bowers (modius@daemon.com.au), David Whiterod (whiterod.david@saugov.sa.gov.au) --->

<!--- declare variables --->
<cfparam name="url.strt" default="1" /> <!--- Please do not edit --->
<cfparam name="url.show" default="10" /> <!--- CUSTOMIZE ME! - How many records per page you'd like displayed --->
<cfset Variables.BarCharacter = "|" /> <!--- CUSTOMIZE ME! - What character should be used to display the bar --->
<cfset Variables.NumOfBars_total = 20 /> <!--- CUSTOMIZE ME! - How many number of bars displayed after page score percentage --->

<cfimport taglib="/farcry/farcry_core/tags/widgets" prefix="widgets" />
<cfimport taglib="/farcry/farcry_core/tags/webskin" prefix="skin">

<cffunction name="safeFormatString" output="false" returnType="string">
	<cfargument name="sString" type="string" required="true">
	<cfscript>
		var sResult = "";
		sResult = XMLFormat(Trim(sString));
		// &apos; is not a valid HTML entity reference (see: http://fishbowl.pastiche.org/2003/07/01/the_curse_of_apos)
		sResult = ReplaceNoCase(sResult,"&apos;", "&##39;", "ALL");
	</cfscript>
	<cfreturn sResult>
</cffunction>

<!--- get active verity collections --->
<cfset variables.lCollections = arrayToList(application.config.verity.aIndices) />

<!--- inbound parameters defaults --->
<cfparam name="form.criteria" default="" />
<cfparam name="form.searchOperator" default="" />
<cfparam name="form.searchformsubmitted" default="0" />

<!---  If form was sent, use cflocation (to allow refresh key without re-submitting to form)
       It also allows them to copy and paste the URL to send to someone else.
       Please add the following hidden variable to your subsequent search forms which refer
       to this page as the action page
           <input type="hidden" name="searchformsubmitted" value="1" />
--->
<cfif form.searchformsubmitted eq 1>
	<cflocation addtoken="no" url="#application.url.webroot#/index.cfm?objectid=#url.objectid#&criteria=#form.criteria#&searchOperator=#form.searchOperator#&strt=#url.strt#&show=#url.show#" />
</cfif>

<cfscript>
	// check if called from x page in results
	if (StructKeyExists(URL, "criteria")){
		form.criteria = url.criteria;}
	if (StructKeyExists(URL, "searchOperator")){
		form.searchOperator = url.searchOperator;}

		/* START - Prepare Verity */
		// check for verity reserved words
		if (findNoCase("not", trim(form.criteria)) or findNoCase("or", trim(form.criteria)) or findNoCase("and", trim(form.criteria))){
			form.searchOperator = "Custom";}
		
		// treat search criteria with appropriate Verity operator
		switch (form.searchOperator)
		{
			case "ALL" :{
				variables.SearchCriteria = replacenocase(trim(form.criteria), " ", " AND ", "ALL");
				break;
			} case "Custom" :{
				variables.SearchCriteria = trim(form.criteria);
				break;
			} case "PHRASE" :{
				variables.SearchCriteria = replacenocase(trim(form.criteria), " ", "<PHRASE>", "ALL");
				break;
			} default :{ // (default) treat as ANY
				if (not findNoCase("not", trim(form.criteria))) {
					SearchCriteria = replacenocase(trim(form.criteria), ",", "", "ALL");
					SearchCriteria = replacenocase(trim(form.criteria), " ", " OR ", "ALL");
				} else {
					SearchCriteria = trim(form.criteria);}
				break;
			}
		}
	
		// get serach results
		if (len(form.criteria)){
		qResults = application.factory.oVerity.search(lCollections=variables.lCollections,searchString=variables.SearchCriteria);}
	/* END - Prepare Verity */
</cfscript>

<cfoutput>
<div id="search-wrapper">
	<form action="</cfoutput><skin:buildLink objectid="#application.navid.search#" urlonly="true"></skin:buildLink><cfoutput>" method="post">
		<input type="text" name="criteria" value="#form.criteria#" />
		<input type="hidden" name="searchformsubmitted" value="1" />
		<select name="searchOperator">
			<option value="ANY"<cfif form.SearchOperator eq "ANY"> selected="selected"</cfif>>Any of these words</option>
			<option value="ALL"<cfif form.SearchOperator eq "ALL"> selected="selected"</cfif>>All of these words</option>
			<option value="PHRASE"<cfif form.SearchOperator eq "PHRASE"> selected="selected"</cfif>>These words as a phrase</option>
		</select>
		<input type="submit" name="action" value="Search" class="searchSubmit" />
	</form></cfoutput>

<cfif StructKeyExists(variables, "qResults") AND qResults.recordCount gt 0>
	<!--- START - Set Usable Variables --->
	<cfscript>
		// START - Validate for mailicious url variables:
		/* 1. must be [numeric] */
		url.strt = IIF(isNumeric(url.strt), url.strt, 1);
		url.show = IIF(isNumeric(url.show), url.show, 1);
		/* 2. must be [whole integers] */
		url.strt = round(url.strt);
		url.show = round(url.show);
		/* 3. cannot be less than one (otherwise possible page crashing) */
		url.strt = IIF(url.strt gte 1, url.strt, 1);
		url.show = IIF(url.show gte 1, url.show, 1);
		// END - Validate for mailicious url variables:

		// Set local variables for displaying record page information
		if (qResults.recordcount-url.strt-1 LTE url.show){
			variables.END_Number = url.strt + url.show;
		} else {
			variables.END_Number = url.strt + url.show-1;
		}
		
		if (qResults.recordcount - url.strt LT url.show){
			variables.END_Number = qResults.Recordcount;
		}
	</cfscript>
	<!--- END - Set Usable Variables --->

	<!--- START - Display Result Count --->
<cfoutput>
	<div class="search-recordCountWrapper">
		<div class="search-recordCount_show">Displaying Results <strong>#url.strt# - #variables.END_Number#</strong></div><!---searchRecordCount_show--->
		<div class="search-recordCount_found">Found <strong>#qResults.recordcount#</strong> result<cfif qResults.recordcount NEQ 1>s</cfif></div><!---searchRecordCount_found--->
	</div>
</cfoutput>
	<!--- END - Display Result Count --->

	<!--- START - Display Search Results --->
	<cfset variables.endRow = url.strt + url.show - 1>
	<cfloop query="qResults" endrow="#variables.endRow#" startrow="#url.strt#">
<cfoutput>
	<div class="search-resultWrapper"></cfoutput>
		<cfset NumOfBars_Highlight = round(replace(score,"%","","all")*(NumOfBars_total/100)) />
		<cfset NumOfBars_Shadow = NumOfBars_total-NumOfBars_Highlight />
<cfoutput>
		<div class="search-resultBars"></cfoutput>
		<cfif NumOfBars_Shadow gt 0>
			<cfoutput>
			<div class="search-resultBars_shadow"></cfoutput><cfloop index="i" from="1" to="#NumOfBars_Shadow#"><cfoutput>#variables.BarCharacter#</cfoutput></cfloop><cfoutput></div></cfoutput>
		</cfif>
		<cfif NumOfBars_Highlight gt 0>
			<cfoutput>
			<div class="search-resultBars_highlight"></cfoutput><cfloop index="i" from="1" to="#NumOfBars_Highlight#"><cfoutput>#variables.BarCharacter#</cfoutput></cfloop><cfoutput></div></cfoutput>
		</cfif>
		<cfoutput>
			<div class="search-resultScore">#score#</div></cfoutput><!--- /div class="searchResultScore"/ --->
		<cfoutput>
		</div></cfoutput><!---.search-resultBars"--->	
		<cfoutput>
		<div class="search-resultRecord"></cfoutput>
		<!--- check for extFile or farcry object --->
		<cfif left(key,2) eq "\\">
			<!--- extFile --->
			<cfoutput>
			<h2 class="search-resultTitle"><a href="#application.url.webroot#/download.cfm?extFile=#key#">#safeFormatString(qResults.title)#</a></h2></cfoutput>
		<cfelse>
			<!--- farcry object --->
			<!--- use fu is possible --->
			<cfoutput>
			<h2 class="search-resultTitle"></cfoutput><skin:buildLink objectid="#key#"><cfoutput>#safeFormatString(qResults.title)#</cfoutput></skin:buildLink><cfoutput></h2></cfoutput>
		</cfif>	
		<cfoutput>
			<p class="search-resultSummary">#qResults.summary#</p>
		</div></cfoutput><!--- /div class="search-resultRecord"/ --->
		<cfif qResults.CurrentRow neq variables.END_Number>
			<cfoutput>
			<div class="search-bottomBorder"></div></cfoutput>
		</cfif>
<cfoutput>
	</div>
	</cfoutput><!---search-resultWrapper"--->
	</cfloop>
	<!--- show previous/next links --->
		
	<widgets:paginationDisplay
		QueryRecordCount="#qResults.RecordCount#"
		FileName="#application.url.conjurer#"
		objectID="#url.objectID#"
		MaxresultPages="5"
		MaxRowsAllowed="#url.show#"
		PageText="Page&nbsp;"
		LayoutNumber="2"
		DivStyle="search-nextPrevious"
		FirstLastPage="numeric"
		layout_previous="&laquo; Previous"
		layout_next="Next &raquo;"
		Separator_mid="&nbsp;"
		CurrentPageWrapper_start="&nbsp;<strong>"
		CurrentPageWrapper_end="&nbsp;</strong>"
		ExtraURLString="criteria=#form.criteria#&searchOperator=#form.searchOperator#">

<cfelseif trim(form.criteria) neq ''>
	<cfoutput>
	<h2 class="search-noResults">Your search for "#form.criteria#" produced no results.</h2></cfoutput>
</cfif>
<cfoutput>
</div>
</cfoutput><!---search-wrapper--->
<cfsetting enablecfoutputonly="no" />